 int yyLineNumber = 1;
 char * yyFileName = NULL;
 int yyeof = 0;
 void yyerror(char *);
 char * xxStrBuf;

 #include <stdlib.h>
 #include <stdio.h>
 #include <ctype.h>
 #include <string.h>

 #include "lexinc.h"
 #include "tokens.h"

DIGIT		[0-9]
HEXDIGIT	[0-9a-fA-F]
HEX		${HEXDIGIT}+
ID		[a-zA-Z][a-zA-Z0-9_]*

%%
^#		DoIncludeCommand();
"//"		DoCCComment();
"/*"		{ DoCComment();
		  /* Maschinenbefehle ab hier einfuegen ----------------------------- */
		}


addq		return xxaddq;
add		return xxadd;
and		return xxand;
clr		return xxclr;
cmp		return xxcmp;
jmp		return xxjmp;
jsr		return xxjsr;
lea		return xxlea;
move		return xxmove;
nop		return xxnop;


"("		{/* Ende des Maschinenbefehl-Bereiches ------------------------------  */
                  return xx_lbr;}
")"		return xx_rbr;
"+"		return xx_add;
"-"		return xx_minus;
","		return xx_com;
";"		return xx_semi;
"@"		return xx_at;

\"		{ char *ptr;
		  if ((ptr = ReadQuotedString()) != NULL) {
                    xxStrBuf = strdup(ptr);
                    return xx_STRING;
		  }
		}


^.data		return xx_DATA;
^.startadr	return xx_STARTADR;
{ID}:		return xx_LABEL;
{ID}		return xx_ID;
#{HEX}		return xx_ConstHEX;
{HEX}		return xx_HEX;
{DIGIT}+	return xx_NUM;




"\n"		yyLineNumber++;
[ \t]		;
<<EOF>>		{ yyeof = 1; return xx_EOF; }

. 		{ char msg[200];
                  if (yyFileName != NULL) {
                    sprintf(msg, "%s:%d:", yyFileName, yyLineNumber);
                  }
                  else {
                    sprintf(msg, "???:%d:", yyLineNumber);
                  }
                  fprintf(yyout, "\n%s unrecognized character `%s'\n", msg, yytext);
                  exit(5);
                }



